Bug 1729693 - openconnect drop vpn connection if packet arrived is larger than MTU and larger than 16384 (Juniper / Pulse)
Summary: openconnect drop vpn connection if packet arrived is larger than MTU and larg...
Keywords:
Status: CLOSED EOL
Alias: None
Product: Fedora
Classification: Fedora
Component: openconnect
Version: 30
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: David Woodhouse
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2019-07-13 15:26 UTC by Roberto Nunin
Modified: 2020-05-26 14:37 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2020-05-26 14:37:03 UTC
Type: Bug


Attachments (Terms of Use)

Description Roberto Nunin 2019-07-13 15:26:55 UTC
Description of problem: 
openconnect VPN ends immediately, when server respond with packets larger that 16384. in my case 20522.


Version-Release number of selected component (if applicable): openconnect-8.02-3.fc30.x86_64


How reproducible: Not sure this happen with all Juniper/Pulse secure appliances, in our case it happen with the newest one, while with the oldest, don't happen.


Steps to Reproduce:
1. start openconnect --protocol=nc https:<VPN URL>>
2. login into VPN server
3. connection ends with : KMP message 301 from server too large (20552 bytes)

Actual results: connection ends.


Expected results: connection must stay, managing extra-size packets.


Additional info: Newest VPN appliance has enabled "Host Checker" functionalities. The appliance is out of mine control, so I cannot test it without "Host Checker" functionality.

Comment 1 David Woodhouse 2019-07-15 08:58:33 UTC
If you just change the bytes[16384] to bytes[32768] at the beginning of the oncp_connect() function in oncp.c does it work?

Comment 2 Roberto Nunin 2019-07-16 19:54:02 UTC
yes, a little bit tricky to build, but it works.

Comment 3 David Woodhouse 2019-07-22 11:48:48 UTC
Thanks for testing. I'll do that in the upcoming 8.04 release. I'd quite like to know what's in that huge config packet though.

At the beginning of the parse_conf_pkt() function there is a length check followed by a call to dump_buf_hex() to dump the whole packet.

Please could you make it dump the packet unconditionally (just cut and paste that line under the closing curly brace } of the 'if (kmpend > pktlen) {' block) and mail it to dwmw2@infradead.org please.

I'll work out if 32768 is sane or if we should be going higher or even making it dynamic.

Comment 4 David Woodhouse 2019-07-24 11:17:15 UTC
I have committed a fix. I'll do an OpenConnect 8.04 release fairly soon and ship updates to Fedora.
In the meantime, it should shortly be built in the COPR at https://copr.fedorainfracloud.org/coprs/dwmw2/openconnect/

Comment 5 Ben Cotton 2020-04-30 21:30:13 UTC
This message is a reminder that Fedora 30 is nearing its end of life.
Fedora will stop maintaining and issuing updates for Fedora 30 on 2020-05-26.
It is Fedora's policy to close all bug reports from releases that are no longer
maintained. At that time this bug will be closed as EOL if it remains open with a
Fedora 'version' of '30'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 30 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

Comment 6 Roberto Nunin 2020-05-03 10:23:14 UTC
I've testes David change. It works on F30, but also in all releases where openconnect is >=8.4.
Root cause for bug is related to proxy setup info  sent over the VPN connection in Corporate VPN setup.
I think that bug can be closed and version changed by David could be released. 

I don't know which is the correct process to complete bug reporting and closing. Apologize for this.

Thanks for reminder.

Comment 7 Roberto Nunin 2020-05-03 10:24:17 UTC
Version >=8.04

Comment 8 Ben Cotton 2020-05-26 14:37:03 UTC
Fedora 30 changed to end-of-life (EOL) status on 2020-05-26. Fedora 30 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.


Note You need to log in before you can comment on or make changes to this bug.